const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const subscriptions = sequelize.define(
    'subscriptions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      status: {
        type: DataTypes.ENUM,

        values: ['TRIAL', 'ACTIVE', 'PAST_DUE', 'CANCELED'],
      },

      trial_ends_at: {
        type: DataTypes.DATE,
      },

      current_period_start: {
        type: DataTypes.DATE,
      },

      current_period_end: {
        type: DataTypes.DATE,
      },

      cancel_at_period_end: {
        type: DataTypes.BOOLEAN,

        allowNull: false,
        defaultValue: false,
      },

      psp_customer_id: {
        type: DataTypes.TEXT,
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  subscriptions.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    db.subscriptions.hasMany(db.payment_transactions, {
      as: 'payment_transactions_subscription',
      foreignKey: {
        name: 'subscriptionId',
      },
      constraints: false,
    });

    //end loop

    db.subscriptions.belongsTo(db.users, {
      as: 'user',
      foreignKey: {
        name: 'userId',
      },
      constraints: false,
    });

    db.subscriptions.belongsTo(db.plans, {
      as: 'plan',
      foreignKey: {
        name: 'planId',
      },
      constraints: false,
    });

    db.subscriptions.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.subscriptions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.subscriptions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return subscriptions;
};
